;------------------------------------------------------------------------------
; 4x4 pixels full screen harddrive ANIM Player
;
; coded in 1999 by Josef Soucek (josef.soucek@spt.cz)
;
; For more information on the IDE64 project,
; please see http://sgi.felk.cvut.cz/~vorlicek/Ide/c64ide.html
; or mail to: Josef.Soucek@spt.cz
;------------------------------------------------------------------------------

;======================================
SETLFS = $ffba
SETNAM = $ffbd
OPEN   = $ffc0
CLOSE  = $ffc3
CHKIN  = $ffc6
CHKOUT = $ffc9
CLRCHN = $ffcc
CHRIN  = $ffcf
CHROUT = $ffd2
CLALL  = $ffe7

scpu_normal   = $d07a
scpu_turbo    = $d07b

;--------------------------------------
; 
; $2000-$23ff -  0 0
; $2400-$27ff -  0 0
; $2800-$2bff -  1 1
; $2c00-$2fff -  1 1
; $3000-$33ff -  2 0
; $3400-$37ff -  2 0
; $3800-$3bff -  3 1
; $3c00-$3fff -  3 1
; $4000-$43ff -  4 0
; $4400-$47ff -  4 0
; $4800-$4bff -  5 1
; $4c00-$4fff -  5 1
; $5000-$53ff -  6 0
; $5400-$57ff -  6 0
; $5800-$5bff -  7 1
; $5c00-$5fff -  7 1
; $6000-$63ff -  8 0
; $6400-$67ff -  8 0
; $6800-$6bff -  9 1
; $6c00-$6fff -  9 1
; -----------
; $7000-$73ff - 10 0
; $7400-$77ff - 10 0
; $7800-$7bff - 11 1
; $7c00-$7fff - 11 1
; $8000-$83ff - 12 0
; $8400-$87ff - 12 0
; $8800-$8bff - 13 1
; $8c00-$8fff - 13 1
; $9000-$93ff - 14 0
; $9400-$97ff - 14 0
; $9800-$9bff - 15 1
; $9c00-$9fff - 15 1
; $a000-$a3ff - 16 0  -- pri 16 kB cfg. musi byt #$35 -> $01
; $a400-$a7ff - 16 0  -- jinak je zde ROM, misto RAM
; $a800-$abff - 17 1  --
; $ac00-$afff - 17 1
; $b000-$b3ff - 18 0
; $b400-$b7ff - 18 0
; $b800-$bbff - 19 1
; $bc00-$bfff - 19 1
;------------------
; $c000-$c3ff -
; $c400-$c7ff - frame 1
; $c800-$cbff -
; $cc00-$cfff - frame 2
;
; $e000 $ffff - Screen 2
;--------------------------------------
;--------------------------------------

W_FRAMES=2        ;-1 +5 = pocet framu screenu na jeden snimek (1=minimum)
                  ;pro 8: 7+5= 12 snimku obrazovky trva jeden frame
                  ;       50(Hz)/12= 4.16 snimku/sec
                  ;       60*4.16= 250 frames/min
                  ;       2(kB)*250= 500 kB zabere 1 min animace
                  ;       4.16*2(kb)= 8.33 kB/sec rychlost cteni z HDD
                  ;-------------------------------------------------------

LINKER=1

DEBUG=0           ;0/1

LOAD=1            ;Loadovat / testovaci mode

FAST=1            ;Pouzivat READ_BL

                  .if FAST=1
read_bl           = $def4
                  .endif
;--------------------------------------

color_screen_addr   = $d800
mcolor_screen_addr  = $e000

;------------------
; $d018 screens

SCREEN0            = %00001000  ;bity 4-7 $0000
SCREEN1            = %00011000  ;bity 4-7 $0400
SCREEN2            = %00101000  ;bity 4-7
SCREEN3            = %00111000  ;bity 4-7
SCREEN4            = %01001000  ;bity 4-7
SCREEN5            = %01011000  ;bity 4-7
SCREEN6            = %01101000  ;bity 4-7
SCREEN7            = %01111000  ;bity 4-7
;--------------------------------------
WAIT_FRAME         = $f5
INFO_0             = $f6
INFO_1             = $f7
frame              = $f8
PRENOS             = $f9           ;0 = neni prenos
scr_0              = $fa
scr_1              = $fb
pom1               = $fc
pom2               = $fd
pom3               = $fe
irq_loop_counter   = $ff

;--------
s_a1               = $22
s_a2               = $23
c_a1               = $24
c_a2               = $25
;
s_b1               = $26
s_b2               = $27
c_b1               = $28
c_b2               = $29
;
y_pom              = $b4
pro_r              = $b5  ;a $b6
;--------------------------------------
                *= $1000
                jsr get_filename
;--------------------------------------
                .if LOAD=0
                *= $2000
;                .binary "anim.ani"
                .binary "jazz2.ani"
                .endif
;--------------------------------------
                *= $1003
                jmp start_anim

;--------------------------------------
; PAL 63 cyklu ; NTSC 64, 65
;--------------------------------------
RASTER          = 47                ;+3 = firstline

irq_disp        = *

;cmp ($02,x)     ; 6 cykl           simuluje zpozdeni pri Open Cfg.
;cmp ($02,x)     ; 6 cykl
;cmp ($02,x)     ; 6 cykl
;cmp ($02,x)     ; 6 cykl
;cmp ($02,x)     ; 6 cykl
;cmp ($02,x)     ; 6 cykl
;cmp ($02,x)     ; 6 cykl
;cmp ($02,x)     ; 6 cykl
;nop             ; 2
                 ; ---
                 ; 50
                                    ;38 to 45 cycles - standard cfg.
                                    ;88 to 95 cycles - open cfg.
                                    
                sta scpu_normal     ; 4/1 ???

                lda #<irq_disp_2    ; 2
                sta $0314           ; 4
                lda #>irq_disp_2    ; 2
                sta $0315           ; 4

                lda #RASTER+2       ; 2
                sta $d012           ; 4
                lda #1              ; 2
                sta $d019           ; 4     ; acknowledge the first raster interrupt
                cli                 ; 2     ; enable interrupts
                                    ; ---
                                    ; 26


                                    ; 64 to 71
                                    ;114 to 121
                                    ; Raster 2x63=126

                        ;------------------------
                nop     ; 73 - 66   123 - 116
                nop     ; 75 - 68   125 - 118  
                nop     ; 77 - 70   ---   120  #
                nop     ; 79 - 72   ---   122  # Pri Open cfg.
                nop     ; 81 - 74   ---   124  #
                nop     ; 83 - 76   ---   126  #
                nop     ; 85 - 78   ---   ---
                nop     ; 87 - 80
                nop     ; 89 - 82
                nop     ; 91 - 84
                nop     ; 93 - 86
                nop     ; 95 - 88
                nop     ; 97 - 90
                nop     ; 99 - 92
                nop     ; 101 - 94
                nop     ; 103 - 96
                nop     ; 105 - 98
                nop     ; 107 - 100
                nop     ; 109 - 102
                nop     ; 111 - 104
                nop     ; 113 - 106
                nop     ; 115 - 108
                nop     ; 117 - 110
                nop     ; 119 - 112
                nop     ; 121 - 114
                nop     ; 123 - 116
                nop     ; 125 - 118
                nop     ; --- - 120  #
                nop     ; --- - 122  # Pri Standard cfg.
                nop     ; --- - 124  #
                nop     ; --- - 126  #
                nop     ; ---   ---
                                          ;Po vykonani irq2, se to sem navrati
                jmp $ea81
;--------------------------------------
irq_disp_2      = *             ; 38 to 39
                lda #<irq_disp  ; 2
                sta $0314       ; 4
                lda #>irq_disp  ; 2
                sta $0315       ; 4
                lda $d012       ; 4
                nop             ; 2 - 56 nebo 57 cykl.
                bit $02         ; 59 nebo 60 cykl.

;nop     - 2 cykly
;bit $24 - 3 cykly

                cmp $d012       ; 4 cykl = 63 nebo 64 cykl (1)
                                ; 63 nebo 64 cykly
                beq nezm        ; 2 nebo 3 cykl.
nezm            = *
                                ; Cycles + 3
                                ; RASTER+3

;--------------------------------------
; Posledni raster v borderu (50)
;--------------------------------------

                lda #$35        ;Vypne ROM (pri 16 kB cfg. se vyuziva $a000)
                                ;Cycles + 5
                sta $01
                                ;Cycles + 8
                nop  
                 
                .if DEBUG=0
                                ;Cycles + 10
                nop
                                ;Cycles + 12
                nop
                                ;Cycles + 14
                nop

                .else

                inc $d020

                .endif
                                ;Cycles + 16
                nop
                                ;Cycles + 18
                nop
                                ;Cycles + 20
                nop
                                ;Cycles + 22
                nop
                                ;Cycles + 24
                nop
                                ;Cycles + 26
                nop
                                ;Cycles + 28
                nop
                                ;Cycles + 30
                nop
                                ;Cycles + 32
                nop
                                ;Cycles + 34
                nop
                                ;Cycles + 36
                nop
                                ;Cycles + 38
                nop
                                ;Cycles + 40
                nop
                                ;Cycles + 42
                nop
                                ;Cycles + 44
                nop
                                ;Cycles + 46
                nop
                                ;Cycles + 48
                nop
                                ;Cycles + 50
                .if DEBUG=0                                

                nop
                                ;Cycles + 52
                nop
                                ;Cycles + 54
                nop
                
                .else
                
                dec $d020
                
                .endif
                                ;Cycles + 56
;                 nop
;                                 ;Cycles + 58
;                 nop
;                                 ;Cycles + 60
;                 nop
;                                 ;Cycles + 62
;                 nop
;                                 ;Cycles + 64

                lda #25                 ;2 cykl
                sta irq_loop_counter    ;3 cykl
                bit $02                 ;3 cykl
                                
;--------------------------------------           RASTER+4
;######################################
;.rep 25

irq_main_loop   = *

;######################################

;--------------------------------------
; RASTER 51, bad line - procesor ma 20 cyklu ? #### PRIROZENA
;--------------------------------------
cmp ($02,x)  ;6

.if DEBUG=1
                 ; #### inc $xxxx , dec $xxxx zrejme kompenzuje
inc $d020    ;6  ; cyklove rozdily vznikle prechodem do nove str. ????
dec $d020    ;6

.else
                 
inc $0fff    ;6
dec $0fff    ;6

.endif

nop      ;Cycles +20
;--------------------------------------
; RASTER 52
;
; -priprava na raster 63 (vnucena bad line)
;--------------------------------------

                lda scr_1
                sta $d018       ;Nastavi adresu obraz.

cmp ($02,x)     ; 6 cykl

; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; bit $02         ; 3 cykl
                ;-------
                ;63 - Raster

;--------------------------------------
; RASTER 53
;--------------------------------------

; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; bit $02         ; 3 cykl
                ;-------
                ;63 - Raster
;--------------------------------------
; RASTER 54
;--------------------------------------

; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; bit $02         ; 3 cykl
                ;-------
                ;63 - Raster
                
                jsr move_block  ;177-12 cyklu -6

cmp ($02,x)     ; 6 cykl
cmp ($02,x)     ; 6 cykl

;--------------------------------------
; RASTER 55, bad line - procesor ma 20 cyklu ? #### VNUCENA
;--------------------------------------
nop
nop
nop

;bit $02      ;Cycles +9
nop
                lda #%00111111  ;bity 0-3
                sta $d011       ;Force Bad line (posun Y o 4 lines)
nop
nop 
;bit $02

nop
bit $02      ;Cycles +23

;--------------------------------------
; RASTER 56
;
; - navratim puvodni hodnoty
;--------------------------------------
                lda scr_0
                sta $d018       ;Nastavi adresu obraz.
                
                lda #%00111011  ;bity 0-3
                sta $d011       ;Zpet Y scroll

; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; bit $02         ; 3 cykl  
                ;-------
                ;63 - Raster
;--------------------------------------
; RASTER 57
;--------------------------------------

; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; bit $02         ; 3 cykl
                ;-------
                ;63 - Raster
;--------------------------------------
; RASTER 58
;--------------------------------------

; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; cmp ($02,x)     ; 6 cykl
; bit $02         ; 3 cykl
                ;-------
                ;63 - Raster
                
                jsr move_block  ;177-12 cyklu -6
                nop
                nop
                
;######################################
; .endr
                dec irq_loop_counter ;5 cykl
                bne irq_main_loop    ;3 cykl

;######################################
;--------------------------------------
                sta scpu_turbo
                    
                lda #RASTER     ; 2
                sta $d012       ; 4
                lda #1          ; 2
                sta $d019       ; 4  acknowledge the irq

;--------------------------------------
                lda #$36        ;Obnovi KERNAL ROM
                sta $01
;--------------------------------------
                lda PRENOS
                bne prenos_probiha
                dec WAIT_FRAME
                bne prenos_probiha
                lda #W_FRAMES
                sta WAIT_FRAME

                lda frame
                sta $de40        ;#######
                lsr
                bcs change_screen
 
                lda #SCREEN0     ;Zobrazi BUFFER 0
                sta scr_0
                lda #SCREEN1
                sta scr_1
                jmp prenos_new
change_screen
                lda #SCREEN2     ;Zobrazi BUFFER 1
                sta scr_0
                lda #SCREEN3
                sta scr_1

prenos_new      = *
                inc frame
                ldx frame
                cpx #20          ;20 - fazi
                bne nova_faze
                ldx #0
                stx frame
nova_faze       = *

                clc
                lda frame_source,x
                sta s_a2
                adc #$04
                sta s_b2
                clc
                lda frame_dest,x
                sta c_a2
                adc #$04
                sta c_b2         ;$cc00

                lda #250         ;250 x 4 = Pocet prenesenych bytu 
                sta PRENOS       ;Odstaruje prenos

                lda frame
                cmp #0           ;Zacina buffer 0
                bne nic
                lda #1
                sta INFO_1
prenos_probiha  = *
                jmp $ea81
                
nic             cmp #10          ;Zacina buffer 1
                bne nic2
                lda #1
                sta INFO_0
nic2            = *
                jmp $ea81
;--------------------------------------
frame_source        = *
                    .byte $20,$28,$30,$38,$40,$48,$50,$58,$60,$68
                    .byte $70,$78,$80,$88,$90,$98,$a0,$a8,$b0,$b8
frame_dest          = *
                    .byte $c0,$c8,$c0,$c8,$c0,$c8,$c0,$c8,$c0,$c8
                    .byte $c0,$c8,$c0,$c8,$c0,$c8,$c0,$c8,$c0,$c8
;-------------------------------------------
; K dispozici 165-12 cyklu ( +6 RTS)
;-------------------------------------------
move_block      = *
                lda PRENOS      ; 3 cykl (zero page)
                beq nic_move    ; 2/3 cykl
                ldy y_pom       ; 3 cykl (zero page)
.rep 4
                lda (s_a1),y    ; 5
                sta (c_a1),y    ; 6
                lda (s_b1),y    ; 5
                sta (c_b1),y    ; 6
                iny             ; 2 x 4 = 96
.endr                           ; ---
                                ; 104 cyklu
        
                bne prenesl_move; 2/3

                sty y_pom       ; 3
                inc s_a2        ; 5
                inc c_a2        ; 5
                inc s_b2        ; 5
                inc c_b2        ; 5
                dec PRENOS      ; 5 (zero page)
                                ; ---
                                ; 135 cyklu

                cmp ($02,x)     ; 6 cykl
                cmp ($02,x)     ; 6 cykl
;                 cmp ($02,x)     ; 6 cykl
;                 cmp ($02,x)     ; 6 cykl
                nop             ; 2
                nop             ; 2
                nop             ; 2 = 165 cyklu
                rts
;------------------
prenesl_move     = *
                 sty y_pom       ; 3 cykl 
                 dec PRENOS      ; 5 (zero page)
                                 ; ---
                                 ; 115
                 bne dojezd_move ; 2/3

                 lda #0          ; 2
                 sta y_pom       ; 3
                 
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 ; cmp ($02,x)     ; 6 cykl
 ; cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 nop             ; 2
 cmp ($02,x)     ; 6 cykl
 bit $02         ; 3 cykl
                 ; ------
                 ; 165

                 rts
                 
dojezd_move      = *
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
;  cmp ($02,x)     ; 6 cykl
;  cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 nop             ; 2
 cmp ($02,x)     ; 6 cykl
 bit $02         ; 3 cykl
                 ; ------
                 ; 165

                 rts
;------------------
nic_move         = *
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
;  cmp ($02,x)     ; 6 cykl
;  cmp ($02,x)     ; 6 cykl
 cmp ($02,x)     ; 6 cykl
 bit $02         ; 3 cykl
                 ; ------
                 ; 165
                rts             ; 6 cyklu
;-------------------------------------------
;00 Background Color Register 0 (53281, $D021)
;01 Upper four bits of Video Matrix
;10 Lower four bits of Video Matrix
;11 Color RAM nybble (area starts at 55296 ($D800))
;-------------------------------------------
;Hi |Low|
;   |   |
;--------
;Vyfilluje $0000-$1f40

fill_screen     = *
                sta pom2
                clc
                adc #$1f        ;+$1f00
                sta pom3

                lda #0
                sta pom1

fill_loop       = *
                lda #0
                tay
loop_A          = *
                sta (pom1),y    ;prvni 4 znaky prazdne
                iny
                cpy #24
                bne loop_A

fill_loop1      = *
                lda #%01001000
                sta (pom1),y
                iny
                lda #%00010010
                sta (pom1),y
                iny
                bne fill_loop1

                inc pom2

fill_loop2      = *
                lda #%01001000
                sta (pom1),y
                iny
                lda #%00010010
                sta (pom1),y
                iny
                cpy #64
                bne fill_loop2
                       
                clc
                lda pom1
                adc #64
                sta pom1
                lda pom2
                adc #0
                sta pom2

                lda pom2
                cmp pom3
                bne fill_loop
                rts
;--------------------------------------
set_screen      = *
                lda $d020
                sta vic_d020
                lda $d021
                sta vic_d021
                lda #0
                sta $d020
                sta $d021
                lda #%00111011  ;posun Y
                sta $d011       ;Zapina grafiku
                lda #%00011000  ;posun X
                sta $d016       ;Zapina multi
                lda scr_0
                sta $d018       ;Nastavi adresu obraz.
                lda $dd02
                ora #%00000011
                sta $dd02       ;Reg A - output
                lda $dd00
                and #%11111100
;                ora #%00000000  ;VIC Banka 3 ($c000-$ffff)
                sta $dd00
                rts
;----------------------------------------
set_irq         = *
                sei
                lda #<irq_disp
                ldx #>irq_disp
                sta $0314       ; set the new interrupt vector
                stx $0315
                lda $d011       ; bit7 - HI bit of raster
                and #%01111111
                sta $d011       ; set the raster interrupt location
                lda #RASTER
                sta $d012
                lda #$7f
                sta $dc0d     ; disable timer interrupts
                sta $dd0d
                ldx #1
                stx $d01a     ; enable raster interrupt
                lda $dc0d     ; acknowledge CIA interrupts
                lsr $d019     ; and video interrupts
                ldy #$00
                sty $d015     ; turn off all sprites
                cli
                rts
;----------------------------------------
; Routina READ - zjednodusena, simuluje routinu IDE64
;----------------------------------------
; Input:  register X,Y - LOW/HI length of buffer
;         register A   - pointer (to zeropage) to startadress of buffer. 
; Output: register X,Y - LOW/HI real readed length of buffer
;         $90          - status.
;----------------------------------------
                .if FAST=0
read_bl         = *
                stx $ae
                sty $af
                tax
                lda $00,x
                sta $c1
                lda $01,x
                sta $c2

                ldy #0                
read_r_loop     = *
                jsr CHRIN
                sta ($c1),y
                
                iny
                bne read_r_loop
                inc $c2
                dec $af
                bne read_r_loop

                rts
                .endif
;--------------------------------------
; Vystup C=1 - EOF
;--------------------------------------
load_0          = *
                ldx #$00
                ldy #$50        ;Load $5000
                
                stx pro_r
                lda #$20        ;From $2000
                sta pro_r+1
                
                lda #pro_r
                
                jsr read_bl
                bcs read_error
                lda $90
                asl
                asl
                bcc load_0_ok
;                sty $0900       ;#####
                tya
                lsr
                lsr
                lsr             ;A - cislo posledniho framu
                sec
;                sta $0901       ;#####
load_0_ok       = *
                rts
;--------------------------------------
load_1          = *
                ldx #$00
                ldy #$50        ;Load $5000
                
                stx pro_r
                lda #$70        ;From $7000
                sta pro_r+1
                
                lda #pro_r
                
                jsr read_bl
                bcs read_error
                lda $90
                asl
                asl
                bcc load_1_ok
;                sty $0902       ;#####
                tya
                lsr
                lsr
                lsr
                clc
                adc #10          ;A - cislo posledniho framu
                cmp #20          ;last frame +1
                bne load_1_cont
                lda #0
load_1_cont     = *
                sec
;                sta $0903        ;#####
load_1_ok       = *
                rts
;--------------------------------------
read_error      = *
                pla
                pla
                sei
                lda #$37
                sta $01
                
                lda #<error_txt
                ldy #>error_txt
                jsr $ab1e

                jmp end_anim2
;--------------------------------------
; ZACATEK #############################
;--------------------------------------
start_anim      = *
                jsr SETNAM

                lda #>mcolor_screen_addr
                jsr fill_screen

                lda #SCREEN0     ;Zobrazuje buffer 0
                sta scr_0
                lda #SCREEN1
                sta scr_1

                lda #0
                sta PRENOS       ;0=neni prenos

;                lda #W_FRAMES

                lda #1            ;1= poprve se neceka
                sta WAIT_FRAME

                lda #0
                sta s_a1
                sta c_a1
                sta s_b1
                sta c_b1
                sta y_pom        ;Vynuluje offset
                sta frame
                sta INFO_0
;                sta INFO_1
                          
;--------------------------------------
                .if LOAD=1
;--------------------------------------
                lda #1          ;Log.num
                ldx $ba         ;Device num
                ldy #0          ;Sec.
                jsr SETLFS

;                lda #end_anim_name-anim_name
;                ldx #<anim_name
;                ldy #>anim_name
;                jsr SETNAM

                jsr OPEN
               
                ldx #1
                jsr CHKIN

                jsr load_0
                php             ;Pokud je zaroven posledni
                pha
                
                ldx #0          ;Prenese data do bufferu 
                clc
                lda frame_source,x
                sta s_a2
                adc #$04
                sta s_b2
                clc
                lda frame_dest,x
                sta c_a2
                adc #$04
                sta c_b2

                lda #250         ;250 x 4 = Pocet prenesenych bytu 
                sta PRENOS       ;Odstaruje prenos
move_loop       = *
                jsr move_block   ;Prenasi data do bufferu 0
                lda PRENOS
                bne move_loop
                
                jsr set_screen

                lda #1
                sta INFO_1

                jsr set_irq

                pla              ;pokud je jiz docteno
                plp
                bcs end_anim
                
                jmp wait_load2

;--------------------------------------
; Prepinani se provede v IRQ
; Nahravat se bude porad, dokola bez prodlevy.
;--------------------------------------

load_loop       = *

wait_load       = *
                lda INFO_0      ;0 = cekat
                beq wait_load
                dec INFO_0
                              
                jsr load_0
                bcs end_anim

wait_load2      = *
                lda INFO_1      ;0 = cekat
                beq wait_load2
                dec INFO_1

                jsr load_1
                bcs end_anim
                 
                jmp load_loop
;--------------------------------------
                .else
                
                jsr set_screen
                jsr set_irq

get_key         = *
                lda #$10
                bit $dc01
                bne get_key
get_key_ok      = *
                lda #$10
                bit $dc01
                beq get_key_ok

                lda #10         ;########### Skonci na 10 framu
                .endif
;--------------------------------------
; A - cislo posledniho framu
;--------------------------------------
end_anim        = *
                cmp frame       ;Ceka dokud neprijde spravny frame
                bne end_anim
                ;
                sei
                lda #$37
                sta $01
end_anim2       = *
                lda #<$ea31
                sta $0314
                lda #>$ea31
                sta $0315
                
                lda #1
                jsr CLOSE
                jsr CLALL
                
                lda #$9b
                sta $d011
                
;                 lda #$37
;                 sta $d012

                lda #$08
                sta $d016
                lda #$14
                sta $d018
                
;                 lda #$0f
;                 sta $d019

                lda #$00
                sta $d01a
                ;
                lda #$07
                sta $dd00
                lda #$3f
                sta $dd02
                lda #$81
                sta $dc0d
                lda $dc0e
                and #$80
                ora #$11
                sta $dc0e
                
                lda vic_d020
                sta $d020
                lda vic_d021
                sta $d021
                cli
                rts
;--------------------------------------
; GET FILENAME
;--------------------------------------
get_filename    = *
                .if LINKER=1
                lda #$37        ;(neni potr, osetreno v IRQ)
                sta $01         ;Spravi linker
                cli
                .endif

                .if LOAD=1
                
                jsr CLALL       ;prepnout na standartni I/O
                lda #<input_txt
                ldy #>input_txt
                jsr $ab1e
          
                ldy #$00
read_name       jsr chrin
                sta anim_name,y    ;zadani nazvu souboru
                cmp #$0d
                beq set_name
                iny
                jmp read_name
set_name        = *
                tya
                ldx #<anim_name
                ldy #>anim_name

                .endif
                rts
;--------------------------------------
input_txt       .text $0d,"VIEW ANIM NAME:",0
error_txt       .text $0d,"READ ERROR",0
;--------------------------------------
vic_d020        *=*+1
vic_d021        *=*+1
anim_name       = *
;--------------------------------------
frame_sequence      = *
                    .byte 0,1,2,3,4,5,4,3,2,1,2,3,4,5,6,7,8,9
                    .byte 8,7,6,5,4,5,4,3,2,1,2,3,4,5,6,7,8,9
                    .byte 10,11,12,13,14,15,16,17,18
                    .byte 17,16,15,14,13,12,11
                    .byte 10,11,12,13,14,15,16,17,18
                    .byte $ff
